<template>
    <div>
        <section class="details">
            <div class="details__wrapper wrapper">
                <div v-if="obj" class="details__obj obj">
                    <div class="obj__box">
                        <p class="obj__title">{{ obj.name }}</p>
                        <p class="obj__date">{{ obj.date }}</p>
                        <div class="obj__banner">
                            <img class="obj__img" :src="`/images/${obj.image}`">
                        </div>
                        <p class="obj__salary">Зарплата от : {{ obj.salary }}</p>
                        <p class="obj__desc">{{ obj.desc }}</p>
                        <button class="obj__button" @click="$router.push({path: `/`})">Откликнуться!</button>
                    </div>
                </div>
            </div>
            <div class="reviews">
                <div class="reviews__wrapper wrapper">
                    <div class="reviews__up-box up-box">
                        <div class="reviews-centered">
                            <h2 class="reviews__headding">Оставьте ваш комментарий</h2>
                        </div>
                        <p class="reviews__error" v-if="error">Пожалуйста введите текст отзыва</p>
                        <textarea type="text" v-model="form.text" class="review__textarea" placeholder="Текс комментария" cols="30" rows="2"></textarea>
                        <div>
                            <button  @click="addComment" class="review__button">Оставить комментарий</button>
                        </div>
                    </div>
                    <div class="reviews__down-box down-box">
                        <p class="down-box__headding">Комментарии</p>
                        <div v-for="(review, index) in reviews" :key="index" class="review__inner">
                            <h3 class="review__name"> {{ review.name }} </h3> 
                            <p class="review__text">{{ review.text }}</p> 
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </div>
</template>

<script>

import { minLength } from 'vuelidate/lib/validators'

export default {
    data: () => ({
        fetchElements:[],
        obj: null,
        reviews: [
            {
                name: 'Alex',
                text: 'review text'
            },
            {
                name: 'Anna',
                text: 'review text'
            }
        ],
        form: {
            name: '',
            text: ''
        },
        error: false
    }),
    async mounted() {
            try {
                await fetch('/api/main.json')
                    .then(response => response.json())
                    .then(data => this.fetchElements = data);
                    this.obj = this.fetchElements.filter(objInfo => objInfo.id == this.$route.params.id)
                    this.obj = this.obj[0]
            } catch(e) {
                console.log(e)
            }
        },
        methods: {
            addComment() {
                if ( this.form.text.length < 4 ) {
                    this.error = true
                } else {
                    this.reviews.reverse()
                    this.reviews.push({
                        name: 'Александр',
                        text: this.form.text
                    })
                }
            }
        },
        validations: {
            form: {
                text: {
                    minLength: minLength(4)
                }
            }
        }
}
</script>

<style>
.review__inner{
    margin-top: 12px;
    border-bottom:1px solid black ;
}

.review__text{
    font-size: 0.9rem;
}

.review__textarea{
    border: 1px black solid;
    height: 80px;
    padding: 8px;
    border-radius: 8px;
}

.down-box__headding{
    font-size: 1.4rem;
}

.reviews__down-box{
    padding: 20px;
}

.reviews__up-box{
    display: flex;
    flex-direction: column;
    padding: 20px;
}

.reviews-centered{
    text-align: center;
}

.reviews__headding{
    font-size: 1.3rem;
    margin-bottom: 40px;
}

.reviews{
    margin-top: 70px;
}
.reviews__error{
    color: red;
    font-size: 0.8rem;
}

.details{
    margin-top: 100px;
}

.wrapper{
    max-width: 1200px;
    margin: 0 auto;
}



.obj__box{
    display: flex;
    flex-direction: column;
    text-align: center;
    padding: 20px;
    border-radius: 8px;
    box-shadow:
       inset 0 -3em 3em rgba(0,0,0,0.1),
             0 0  0 2px rgb(0,0,0,0.1),
             0.3em 0.3em 1em rgba(0,0,0,0.3);
}

.obj__title{
    font-size: 2.3rem;
}

.obj__img{
    margin-top: 40px;
    width: 600px;
    height: 400px;
}

.obj__button{
    background-color:#009688;
    color: white;
    padding: 8px 4px;
    margin-top: 70px;
    border-radius: 8px;
}

.review__button{
    border-radius: 8px;
    background-color:#009688;
    color: white;
    padding: 8px 10px; 
    margin-top: 15px;
}

.obj__date{
    font-size: 0.7rem;
}

.obj__desc{
    margin-top: 15px;
}

.v-application p {
    margin-bottom: 0;
}

@media screen and (max-width: 800px) {
    .obj__img{
        width: 300px;
        height: 200px;
    }
    .obj__title{
        font-size: 1.7rem;
    }
    .obj__desc{
        font-size: 1rem;
    }
    .obj__salary{
        font-size: 1rem;
    }
    .obj__button{
        font-size: 0.9rem;
    }
    .review__button{
        font-size: 0.9rem;
    }
}

@media screen and (max-width: 450px) {
    .obj__img{
        width: 200px;
        height: 150px;
    }
    .obj__desc{
        font-size: 0.7rem;
    }
    .obj__salary{
        font-size: 0.65rem;
    }
    .down-box__headding{
        font-size: 1rem;
    }
}
</style>